﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMotorboat.CollectionGenericObjects;

public class StorageCollection<T>
    where T : class
{
    
    readonly Dictionary<string, ICollectionGenericObjects<T>> _storages;

    public List<string> Keys => _storages.Keys.ToList();

    public StorageCollection()
    {
        _storages = new Dictionary<string, ICollectionGenericObjects<T>>();
    }

    
    public void AddCollection(string name, CollectionType collectionType)
    {
        // TODO проверка, что name не пустой и нет в словаре записи с таким ключом
        // TODO Прописать логику для добавления
        if (name == null || _storages.ContainsKey(name)) { return; }
        switch (collectionType)

        {
            case CollectionType.None:
                return;
            case CollectionType.Massive:
                _storages[name] = new MassiveGenericObjects<T>();
                return;
            case CollectionType.List:
                _storages[name] = new ListGenericObjects<T>();
                return;
        }
    }

   
    public void DelCollection(string name)
    {
        // TODO Прописать логику для удаления коллекции
        if (_storages.ContainsKey(name))
            _storages.Remove(name);
    }

   
    public ICollectionGenericObjects<T>? this[string name]
    {
        get
        {
            // TODO Продумать логику получения объекта
            if (name == null || !_storages.ContainsKey(name)) { return null; }
            return _storages[name];
        }
    }
}